//  Eratosthenes Sieve prime number benchmark in Java
/*
 * Small cosmetic rewrite by Petter Reinholdtsen <pere@td.org.uit.no>
 */

public class Sieve {

  static int score = 0;
  static int iterations = 0;
  static double seconds = 0.0;
  static long elapsedTime = 0;

  public static void main(String[] args) {
    try {
      runSieve();

      // XXX Hm, what is acceptable?
      if (score > 10)
	System.out.print("PASSED: ");
      else
	System.out.print("FAILED: (to low score)");

      System.out.println("score="+score+", "+
			 iterations + " iterations in "+seconds+
			 " seconds (" + elapsedTime + " ms)");
    } catch (Exception e) {
      System.out.println("FAILED: Exception "+e);
    }
  }
  static void runSieve()
    throws Exception
    {
     int SIZE = 8190;
     boolean flags[] = new boolean[SIZE+1];
     int i, prime, k, iter, count;
     long startTime;

     startTime = System.currentTimeMillis();
     while (true) {
        count=0;
        for(i=0; i<=SIZE; i++) flags[i]=true;
        for (i=0; i<=SIZE; i++) {
           if(flags[i]) {
              prime=i+i+3;
              for(k=i+prime; k<=SIZE; k+=prime)
                 flags[k]=false;
              count++;
           }
        }
        iterations++;
        elapsedTime = System.currentTimeMillis() - startTime;
        if (elapsedTime >= 10000) break;
     }
     seconds = ((int)elapsedTime) / 1000.0;
     score = (int) Math.round(iterations / seconds);
     if (count != 1899)
       throw new Exception("count <> 1899");
  }
}
